/*

This is the header file to define the MyEventSegment class, which 
is derived from CEventSegment.  This class can be used to read 
out any number of CAEN modules covered by the CAENcard class. 
Those cards include the V785, V775, and  V792.

Tim Hoagland
11/3/04
s04.thoagland@wittenberg.edu

*/


#ifndef __MYEVENTSEGMENT_H
#define __MTEVENTSEGMENT_H
#include <spectrodaq.h>
#include <CEventSegment.h>
#include <CDocumentedPacket.h>
#include  <CCAENV1x90.h>
#define CAENTIMEOUT 50


// Declares a class derived from CEventSegment
class MyEventSegment : public CEventSegment   
{
private:
  CDocumentedPacket m_MyPacket;  
  CCAENV1x90* m_TDC;  
  unsigned int Slot;
  unsigned long Base;
  unsigned int Crate;
public:
  MyEventSegment(unsigned int slot, unsigned int crate, unsigned long Base);
              // Defines packet info

  virtual void Initialize();                    
             // One time Module setup

  virtual void Clear();            
             // Resets data buffer

  virtual unsigned int MaxSize();               

  virtual DAQWordBufferPtr& Read(DAQWordBufferPtr& rBuf);  
             // Reads data buffer
};
#endif
