#include "MyEventProcessor.h"
#include <TCLAnalyzer.h>
#include <Event.h>
#include <FilterBufferDecoder.h>
#define MAXHITSPERCHANNEL 1
#include <stdint.h>
int i=0;

MyEventProcessor::MyEventProcessor(unsigned int nSlot, unsigned int nBase) : 
  m_nVsn(nSlot),
  m_nBaseParameter(nBase)
{

}

Bool_t MyEventProcessor::operator()(void* pEvent, CEvent& rEvent,
				    CAnalyzer& rAnalyzer, CBufferDecoder& rDecoder)
{
  TranslatorPointer<uint16_t> pw(*(rDecoder.getBufferTranslator()), pEvent);
  uint16_t nWords = *pw++;
  CTclAnalyzer& rAna((CTclAnalyzer&)rAnalyzer);
  rAna.SetEventSize(nWords*sizeof(uint16_t));
  uint32_t nLongs = (nWords-1)*sizeof(uint16_t)/sizeof(uint32_t);

  int nSlot  = -1;
  bool FormatOK;
  long hits[32][MAXHITSPERCHANNEL];
  long nHits[32];
  for (int i =0; i < 32; i++) {
    nHits[i] =0;}


  while(nLongs)                  // Search packet for ID tag
    {
      uint32_t data = *pw;
      ++pw;
      data |= *pw<<16;
      ++pw;

      nLongs--;
      if(CCAENV1x90Data::isGlobalHeader(data)) {               
	nSlot = CCAENV1x90Data::BoardNumber(data);       // (7)
      }
      if(CCAENV1x90Data::isTDCHeader(data)) {
      }
      if(CCAENV1x90Data::isTDCTrailer(data)) {
      }
      if(CCAENV1x90Data::isTDCError(data)) {
      }
      if(CCAENV1x90Data::isMeasurement(data)) {                
	int nChannel = CCAENV1x90Data::ChannelNumber(data, false);
	long nValue  = CCAENV1x90Data::ChannelValue(data, false);
	if(nSlot == m_nVsn) {
	  if(nHits[nChannel] < MAXHITSPERCHANNEL) {
	    hits[nChannel][nHits[nChannel]] = nValue;   // (8)
	    nHits[nChannel]++;
	  }
	}
      }
      if(CCAENV1x90Data::isGlobalTrailer(data)) {              
	if(nLongs) {
	  FormatOK = false;
	} else {                                       // (9)
	  FormatOK = (nSlot == m_nVsn);
	}
      }
    }
  // Store at most MAXHITSPERCHANNEL hits from each channel from the hits
  // vector.

  if(FormatOK) {                                    // (10)

    // Channel 0 is the gate.  There must be exactly one gate hit to
    // get decent resolution, all channels must be subtracted from the
    // digitized time of the gate as the gate time used in trigger subtraction
    // is only good to 25ns:

    if(nHits[0] == 1) 
      {
      long nGateTime = hits[0][0]; // Gate time.    // (11)
      int nParam = m_nBaseParameter;
      for(int nChan = 1; nChan < 2; nChan++) { // Real chans start at 1.
        for(int ihit = 0; ihit < nHits[nChan]; ihit++) {
          rEvent[nParam + ihit] = nGateTime - hits[nChan][ihit]; // (12)
        }
        nParam += MAXHITSPERCHANNEL;
        
        }
      }

  }
      return kfTRUE;
}



